<?

// -----------------------------------------------------------------
// DCS Requirement Database interface functions
// Author: protopop@jlab.org - March 2008
// -----------------------------------------------------------------

include_once("/www/php_functions/dcs_private.inc");

// Color scheme
$header_font = "ffffff";
$header_bg = "46a3db";
$oddrowcolor = "e9e0e0";
$evenrowcolor = "e0e0ee";
$dcs_user = "Guest";

// Special cross-referenced fields
$specials = "contact,subdetector,institute,unit,type";

function is_odd($number) {
   return $number & 1; // 0 = even, 1 = odd
}

function tablesMenu(){

 db_connect("dsc_req_db_admin",DCS_REQ);
 $query = "show tables";
 $result = mysql_query($query);
 $num_results =  mysql_num_rows($result);

 echo "<p><div class=\"head2r\">Tables in DCS_REQ</div>";

 for ($i=0; $i <$num_results; $i++) {
   $row = mysql_fetch_array($result);
   $tname = $row[0];
   if($i > 0) { echo " | "; }
   echo "<a href='interactiveTable.php?name=". $tname ."'><b>".  $tname ."</b></a>\n";
 }
 echo "</p>\n";
}

//------ Private Functions --------
// will be moved to dcs_private.inc
function extractUser($token){
  // not yet implemented
  return $token;
}

function createToken($uid){
  // not yet implemented
  return $uid;
}

function isAuthenticated($user){
  // not yet implemented
  return 1;
}
function checkPass($user,$pass){
  // not yet implemented
  $okay=0;
  if(strcasecmp($user,"protopop@jlab.org")==0 && strcasecmp($pass,"kuku")==0) $okay=1;
  return $okay;
}
//----------------------------------

function showLoginStatus($uid){
  if(!empty($uid) && strcasecmp($uid,"guest")!=0){
    echo "<div style=\"align:right; padding: 5px; border: medium solid #". $GLOBALS['header_bg'] .";\">";
    echo "<img src='images/icon-unlock.gif'> You are logged in as <b>$uid</b> | <a href='logon.php?action=logout'>Logout</a></div>";
  } else {
    echo "<img src='images/icon-lock.gif'> <a href=\"logon.php\"><b>Logon</b></a>";
  }
}

function describeTable($name){

 db_connect("dsc_req_db_admin",DCS_REQ);
 $query = "describe $name";
 $result = mysql_query($query);
 $num_results =  mysql_num_rows($result);

 echo "<p><table cellpadding=2 cellspacing=3>";
 makeHeader(array("Field","Type","Null","Key","Default","Extra"));

 for ($i=0; $i <$num_results; $i++) {
   $row = mysql_fetch_array($result);
   echo "<tr style=\"background-color:e0e0e0;\">";
   echo "<td align='center'>". $row["Field"] ."</td>";
   echo "<td align='center'>". $row["Type"] ."</td>";
   echo "<td align='center'>". $row["Null"] ."</td>";
   echo "<td align='center'>". $row["Key"] ."</td>";
   echo "<td align='center'>". $row["Default"] ."</td>";
   echo "<td align='center'>". $row["Extra"] ."</td></tr>\n";
 }
 echo "</table></p>\n";
}


function getFields($table){

  db_connect("dsc_req_db_admin",DCS_REQ);
  $query = "describe $table";
  $result = mysql_query($query);
  $num_results =  mysql_num_rows($result);
  $columns = array();
  for ($i=0; $i <$num_results; $i++) {
    $row = mysql_fetch_array($result);
    array_push($columns, $row["Field"]);
  }
  return $columns;
}


function modifyButton($table, $key){
  echo "<form action='modify.php' name='modf'><td align='center'>";
  echo "<input type='hidden' name='table' value='". $table ."'>";
  echo "<input type='hidden' name='key' value='". $key ."'>";
  echo "<input type='hidden' name='dbaction' value='modify'>";
  echo "<input type='submit' value='Modify'></td></form>";
}


function selectList($table, $default) {

 db_connect("dsc_req_db_admin",DCS_REQ);
 $query = "select id, name from $table order by name";
 $result = mysql_query($query);
 $num_results =  mysql_num_rows($result);

 $field = substr(strtolower($table), 0, -1);
 $code = "<select name=\"$field\">";
 for ($i=0; $i <$num_results; $i++) {
   $row = mysql_fetch_array($result);
   if($row["id"]==$default)
     $code .= "  <option selected value=\"". $row["id"] ."\">". $row["name"] ."\n";
   else
     $code .= "  <option value=\"". $row["id"] ."\">". $row["name"] ."\n";
 }
 $code .= "</select>\n";

 return $code;
}

function inputField($name, $value){
  echo "<td><input type=\"text\" name=\"$name\" width='auto' value=\"$value\"></td>";
}

function hiddenInput($name, $value){
  echo "<td width='auto' align='center'>$value<input type=\"hidden\" name=\"$name\" value=\"$value\"></td>";
}

function simpleCell($align, $value){
  if(substr_count($value,"?")>0 || strcasecmp($value,"NULL")==0){
    // Higlight in red question marked or NULL
    echo "<td width='auto' align='$align' style='font-weight:bold;color:ff0000'>$value</td>";
  } else {
    echo "<td width='auto' align='$align'>$value</td>";
  }
}

function dropMenu($key, $default){  
  $dropList = selectList(ucfirst($key)."s", $default);
  echo "<td width='auto' align='center'>$dropList</td>";
}

function tableHeader($name, $extra){
  $fields = getFields($name);
  echo "<thead>\n";
  echo "<tr style=\"color:". $GLOBALS['header_font'] ."; background-color:". $GLOBALS['header_bg'] .";\">";
  foreach ($fields as $item) {
    if(strcasecmp($item, "id")!=0)
      echo "<th>". ucfirst($item) ."</th>";
  }
  if($extra!="")
    echo "<th>". ucfirst($extra) ."</th>";
  echo "</tr></thead>\n";
}

function makeHeader($fields){
  echo "<tr style=\"color:". $GLOBALS['header_font'] ."; background-color:". $GLOBALS['header_bg'] .";\">";
  foreach ($fields as $item) {
    echo "<td align='center'><b>". ucfirst($item) ."</b></td>";
  }
  echo "</tr>\n";
}

function inputCell($name, $value){

  $specials = $GLOBALS['specials'];
  $noaccess = "id,ID,timestamp,lastupdatedby";

  if(strcasecmp($name,"lastupdatedby")==0)
    $value=$GLOBALS['dcs_user'];
  if(strcasecmp($name,"timestamp")==0)
    $value="now";

  if(substr_count($noaccess,$name))
    hiddenInput($name, $value);
  else if(substr_count($specials,$name))
    dropMenu($name, $value);
  else
    inputField($name, $value);
}


function genericTable($name, $query){
  
  $modifiable = $GLOBALS['modifiable'];
  $specials = $GLOBALS['specials'];
  $spcount = 0;

  echo "<p><div class=\"head3r\">$name</div></p>";
  echo "<p><table class='sortable' cellpadding='2' cellspacing='3'>";

  // Header
  tableHeader($name, "Action");

  // Content
  db_connect("dsc_req_db_admin",DCS_REQ);
  $result = mysql_query("$query");
  $num_results =  mysql_num_rows($result);
  echo "<tbody>\n";
  for ($i=0; $i <$num_results; $i++) {
    $row = mysql_fetch_array($result);
    if(is_odd($i))
      echo "<tr style=\"background-color:". $GLOBALS['oddrowcolor'] .";\">";
    else
      echo "<tr style=\"background-color:". $GLOBALS['evenrowcolor'] .";\">";
    foreach (getFields($name) as $item) {
      if(strcasecmp($item,"id")!=0){
	if(substr_count($specials,$item)) {
          simpleCell("center",$row[ucfirst($item)]);
	  $spcount++;
        } else
	  simpleCell("center",$row[$item]);
      }
    }
    if($modifiable){
      // Modify button
      if($spcount)
	modifyButton($name, $row["ID"]);
      else 
	modifyButton($name, $row["id"]);
    } else {
      echo "<td align='center'>N/A</td>";
    }
    echo "</tr>\n";
  }
  echo "</tbody>\n";

  if($modifiable){
    // Insert form
    echo "<tfoot>\n";
    echo "<form action=\"dbaction.php\" name=\"addf\">";
    echo "<tr style=\"background-color:46a3db;\">";
    foreach (getFields($name) as $item) {
      if(strcasecmp($item, "ID")!=0){
	inputCell($item,"?");
      }
    }
    echo "<td align='center'><input type='hidden' name='dbaction' value='add'>";
    echo "<input type='hidden' name='table' value='$name'>";
    echo "<input type='submit' value='Add'></td>";
    echo "</tr></form>";
    echo "</tfoot>\n";
  }
  echo "</table></p>";
}


function anyTable($name){

  // Main table fields
  $fields = "";
  $commas = 0;
  foreach (getFields($name) as $item) {
    if($commas) $fields .= ", ";
    if(strcmp($item,"id")==0)
      $fields .= $name .".". $item . " as ID ";
    else
      $fields .= $name .".". $item;
    $commas++;
  }

  // Special cases
  if (strcasecmp($name, "ProcessVariables")==0) {
    genericTable("ProcessVariables","select $fields, Contacts.name as Contact, Subdetectors.name as Subdetector, ProcessVariables.id as ID, Types.name as Type, Units.name as Unit from Contacts, Subdetectors, Types, Units, ProcessVariables where (Contacts.id like ProcessVariables.contact) and (Subdetectors.id like ProcessVariables.subdetector) and (Types.id like ProcessVariables.type) and (Units.id like ProcessVariables.unit)");
  } else if (strcasecmp($name, "Contacts")==0) {
    genericTable("Contacts", "select $fields, Institutes.name as Institute, Institutes.id from Contacts, Institutes where (Contacts.institute like Institutes.id) order by Institutes.name");
  } else if (strcasecmp($name, "Subdetectors")==0) {
    genericTable("Subdetectors", "select $fields, Contacts.id, Contacts.name as Contact from Subdetectors, Contacts where contact like Contacts.id");
  } else  {
    genericTable($name, "select * from $name");
  }
  
  echo "<a href=\"#\" onmouseover=\"show(event, 'Table:description'); return true\" onmouseout=\"hide('Table:description'); return true;\">+ Table Description</a>\n";
}


?>
